#ifndef lisa_minigrail_dfa_h
#define LISA_MINIGRAIL_DFA_H

namespace minigrail
{

class DFA{
//Legend :
// " // " = implemented
// " * " =  has been inserted into symbol table
// " + " =  the function has been installed in the compiler

public:

	static int 			size(mGDFA dfa);
	static int  		maxstring(mGDFA dfa);

	static mGDFA 		*reverse(mGDFA dfa);//
	static mGDFA 		*uniondfa(mGDFA dfa1,mGDFA dfa2);
	static mGDFA		*plus(mGDFA dfa);
	static mGDFA		*star(mGDFA dfa);
	static mGDFA		*reachable(mGDFA dfa);
	static mGDFA		*reduce(mGDFA dfa);
	static mGDFA		*complete(mGDFA dfa);
	static mGDFA		*cartesian(mGDFA dfa);
	static mGDFA		*cross(mGDFA dfa1, mGDFA dfa2);
	static mGDFA		*shuffle(mGDFA dfa1,mGDFA dfa2);
	static mGDFA		*nfatodfa(mGDFA dfa);
	static mGDFA		*concat(mGDFA dfa1, mGDFA dfa2);

	static bool			isDeterministic(mGDFA dfa);
	static bool			isFinite(mGDFA dfa);
	static bool			isComplete(mGDFA dfa);
	static bool			isUniversal(mGDFA dfa);

};

}
#endif
