/*
    file: mGNFAUnion.cpp
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

	Modified by Brandon Stewart July 2015
	  - Added namespace minigrail

*/

namespace minigrail
{

void mGNFAUnion(const mGNFA& nfa1, const mGNFA& nfa2, mGNFA& unioned,
		bool check_unique)
{
	//union all of them without check

	unioned.getStartStates().disjoint_union(nfa1.getStartStates());
	unioned.getStartStates().disjoint_union(nfa2.getStartStates());

	unioned.getFinalStates().disjoint_union(nfa1.getFinalStates());
	unioned.getFinalStates().disjoint_union(nfa2.getFinalStates());

	unioned.getTransitions().disjoint_union(nfa1.getTransitions());
	unioned.getTransitions().disjoint_union(nfa2.getTransitions());

	//if we need to make sure it is
	if (check_unique)
	{

		unioned.getStartStates().unique_array();
		unioned.getTransitions().unique_array();
		unioned.getFinalStates().unique_array();

	}

}

} //namespace minigrail
