/*
    file: mGInt.h
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>


	Modified by Brandon Stewart July 2015
	  - Added namespace minigrail


 This is a class represents a positive integer
 that can be as big as we want

 Basically we store the numbers in raw binary

 */

#ifndef _MGINT
#include <string>

//for compiling
//class mGState;
//TODO do not want this , how to make valid forward declaration?
#include "../../TheoryObjects/mGState/mGState.h"

namespace minigrail
{

class mGInt
{

private:

	char * ptr; // the pointer to the data
	int size;

public:
	//constructor
	//get the int for a set of mGState
	//a new mGInt is constructed based on the states in mGSet
	//{1 2 3} will be a mGInt of one char : 00001110
	mGInt(const mGSet<mGState>&);

	//get  mGInt from a string
	//copy the memory and take as a mGInt
	mGInt(const std::string&);
	mGInt(const mGInt&);


	~mGInt()
	{

		delete[] ptr;
		ptr = NULL;
	}

	inline const int getSize() const
	{
		return size;

	}

	inline const char* getData() const
	{

		return ptr;
	}

	void toBinray(string&);

	void toBitSet(string&) const;

	//Comparison
	const int compare(const mGInt&) const;
	inline  bool operator==(const mGInt& c) const
	{
		return ((compare(c)) == 0);
	}
	inline  bool operator<(const mGInt& c) const
	{
		return ((compare(c)) < 0);
	}
	inline  bool operator>(const mGInt& c) const
	{
		return ((compare(c)) > 0);
	}

};

} //namespace minigrail

#define _MGINT
#endif
