/*
    file: mGDFA.cpp
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

	Modified by Brandon Stewart July 2015
	  - Added namespace minigrail

copy from a NFA
*/

namespace minigrail
{

mGDFA::mGDFA(const mGNFA& n)
{
	//do a nfa to dfa transformation

	//std::cout<<"NEED FILL THE FUNCTION";
	*this = n;

}

bool mGDFA::addTransition(const mGTransition& t)
{
	//check if there is a violation
	for (int a = 0; a < transitions.size(); a++)
	{
		if (transitions[a].sameStartAndLabel(t) && !(transitions[a] == t))
			return false; // nothing to add
	}

	mGNFA::addTransition(t);
	return true;

}

bool mGDFA::getDestination(const mGState& s, const int l, mGState& end)
{
	bool debug;
	if (DEBUG_TRIGGERED(DEBUG_mGDFA_getDestination)
			|| DEBUG_TRIGGERED(DEBUG_ALL))
	{
		debug = true;
		std::cout << "Debug output for  mGDFA::getDestination is enabled."
				<< std::endl;
	}

	attach();

	mGSet<mGTransition> ts = transitionsByState[s];
	for (int a = 0; a < ts.size(); a++)
	{
		if (ts[a].getLabel() == l)
		{
			end = ts[a].getEnd();
			if (debug)
			{
				std::cout << "from " << s << " with " << l << " goes to " << end
						<< std::endl;
			}
			return true;
		}
	}

	end.setNumber(NULL_INT);

	if (debug)
	{
		std::cout << "from " << s << " with " << l << " goes to " << end
				<< std::endl;
	}

	return false;

}

} //namespace minigrail
